import React from 'react';
import { PropsWithMetadata, Theme } from '@highlight-ui/utils-commons';
import { ButtonType, ButtonState } from './types';
export declare type ButtonRef = React.Ref<HTMLButtonElement>;
export declare type ButtonProps = React.PropsWithChildren<PropsWithMetadata<{
    /** Makes the component behave as a block element (take up the whole available space) */
    block?: boolean;
    /** Allows providing a custom class name */
    className?: string;
    /** Determines the state of the button */
    buttonState?: ButtonState;
    /** A callback that will be fired ones the button is clicked */
    onClick?: React.MouseEventHandler;
    /** Determines whether to render the outline for the button or not */
    outline?: boolean;
    /** Allows providing the custom CSS */
    style?: React.CSSProperties;
    /** Tab index HTML property */
    tabIndex?: number;
    /** Allows specifying the styling of the button */
    theme?: Theme;
    /** Button Type HTML property */
    type?: ButtonType;
}>> & Omit<React.ComponentPropsWithoutRef<'button'>, 'disabled'>;
declare const Button: React.ForwardRefExoticComponent<{
    /** Makes the component behave as a block element (take up the whole available space) */
    block?: boolean | undefined;
    /** Allows providing a custom class name */
    className?: string | undefined;
    /** Determines the state of the button */
    buttonState?: ButtonState | undefined;
    /** A callback that will be fired ones the button is clicked */
    onClick?: React.MouseEventHandler<Element> | undefined;
    /** Determines whether to render the outline for the button or not */
    outline?: boolean | undefined;
    /** Allows providing the custom CSS */
    style?: React.CSSProperties | undefined;
    /** Tab index HTML property */
    tabIndex?: number | undefined;
    /** Allows specifying the styling of the button */
    theme?: Theme | undefined;
    /** Button Type HTML property */
    type?: ButtonType | undefined;
} & {
    metadata?: import("@highlight-ui/utils-commons").ComponentMetadata | undefined;
} & {
    children?: React.ReactNode;
} & Omit<Pick<React.DetailedHTMLProps<React.ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement>, "key" | keyof React.ButtonHTMLAttributes<HTMLButtonElement>>, "disabled"> & React.RefAttributes<HTMLButtonElement>>;
export default Button;
